/* arena.c generated by valac 0.48.15, the Vala compiler
 * generated from arena.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())
typedef ObjectType (*ArenaMapper) (ObjectType obj, gpointer user_data);

#define TYPE_ARENA (arena_get_type ())
#define ARENA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA, Arena))
#define ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA, ArenaClass))
#define IS_ARENA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA))
#define IS_ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA))
#define ARENA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA, ArenaClass))

typedef struct _Arena Arena;
typedef struct _ArenaClass ArenaClass;
typedef struct _ArenaPrivate ArenaPrivate;

#define ARENA_TYPE_COORDS (arena_coords_get_type ())
typedef struct _ArenaCoords ArenaCoords;

#define TYPE_ARENA_ITERABLE (arena_iterable_get_type ())
#define ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA_ITERABLE, ArenaIterable))
#define ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA_ITERABLE, ArenaIterableClass))
#define IS_ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA_ITERABLE))
#define IS_ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA_ITERABLE))
#define ARENA_ITERABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA_ITERABLE, ArenaIterableClass))

typedef struct _ArenaIterable ArenaIterable;
typedef struct _ArenaIterableClass ArenaIterableClass;
typedef struct _ParamSpecArena ParamSpecArena;
typedef struct _ArenaIterablePrivate ArenaIterablePrivate;
#define _arena_unref0(var) ((var == NULL) ? NULL : (var = (arena_unref (var), NULL)))

#define ARENA_ITERABLE_TYPE_ITERATOR (arena_iterable_iterator_get_type ())
#define ARENA_ITERABLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIterator))
#define ARENA_ITERABLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))
#define ARENA_ITERABLE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))

typedef struct _ArenaIterableIterator ArenaIterableIterator;
typedef struct _ArenaIterableIteratorClass ArenaIterableIteratorClass;
typedef struct _ArenaIterableIteratorPrivate ArenaIterableIteratorPrivate;
typedef struct _ArenaIterableParamSpecIterator ArenaIterableParamSpecIterator;
typedef struct _ParamSpecArenaIterable ParamSpecArenaIterable;

struct _Arena {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ArenaPrivate * priv;
};

struct _ArenaClass {
	GTypeClass parent_class;
	void (*finalize) (Arena *self);
};

struct _ArenaPrivate {
	gint _width;
	gint _height;
	ObjectType* arena;
	gint arena_length1;
	gint _arena_size_;
};

struct _ArenaCoords {
	gint x;
	gint y;
};

struct _ParamSpecArena {
	GParamSpec parent_instance;
};

struct _ArenaIterable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ArenaIterablePrivate * priv;
};

struct _ArenaIterableClass {
	GTypeClass parent_class;
	void (*finalize) (ArenaIterable *self);
};

struct _ArenaIterablePrivate {
	Arena* arena;
	gint initial_x;
	gint initial_y;
};

struct _ArenaIterableIterator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ArenaIterableIteratorPrivate * priv;
};

struct _ArenaIterableIteratorClass {
	GTypeClass parent_class;
	void (*finalize) (ArenaIterableIterator *self);
};

struct _ArenaIterableIteratorPrivate {
	gint initial_position;
	gint width;
	gint size;
	gint i;
};

struct _ArenaIterableParamSpecIterator {
	GParamSpec parent_instance;
};

struct _ParamSpecArenaIterable {
	GParamSpec parent_instance;
};

static gint Arena_private_offset;
static gpointer arena_parent_class = NULL;
static gint ArenaIterable_private_offset;
static gpointer arena_iterable_parent_class = NULL;
static gint ArenaIterableIterator_private_offset;
static gpointer arena_iterable_iterator_parent_class = NULL;

GType object_type_get_type (void) G_GNUC_CONST;
gpointer arena_ref (gpointer instance);
void arena_unref (gpointer instance);
GParamSpec* param_spec_arena (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_arena (GValue* value,
                      gpointer v_object);
void value_take_arena (GValue* value,
                       gpointer v_object);
gpointer value_get_arena (const GValue* value);
GType arena_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Arena, arena_unref)
Arena* arena_new (gint width,
                  gint height);
Arena* arena_construct (GType object_type,
                        gint width,
                        gint height);
void arena_clear (Arena* self);
GType arena_coords_get_type (void) G_GNUC_CONST;
ArenaCoords* arena_coords_dup (const ArenaCoords* self);
void arena_coords_free (ArenaCoords* self);
gboolean arena_are_coords_valid (Arena* self,
                                 ArenaCoords* coords);
ObjectType arena_get (Arena* self,
                      gint x,
                      gint y);
void arena_set (Arena* self,
                gint x,
                gint y,
                ObjectType obj);
Arena* arena_map (Arena* self,
                  ArenaMapper mapper,
                  gpointer mapper_target);
gint arena_count (Arena* self,
                  GeePredicate predicate,
                  gpointer predicate_target);
gpointer arena_iterable_ref (gpointer instance);
void arena_iterable_unref (gpointer instance);
GParamSpec* param_spec_arena_iterable (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_arena_iterable (GValue* value,
                               gpointer v_object);
void value_take_arena_iterable (GValue* value,
                                gpointer v_object);
gpointer value_get_arena_iterable (const GValue* value);
GType arena_iterable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterable, arena_iterable_unref)
ArenaIterable* arena_iterate_from (Arena* self,
                                   gint x,
                                   gint y);
ArenaIterable* arena_iterable_new (Arena* arena,
                                   gint initial_x,
                                   gint initial_y);
ArenaIterable* arena_iterable_construct (GType object_type,
                                         Arena* arena,
                                         gint initial_x,
                                         gint initial_y);
gint arena_get_width (Arena* self);
gint arena_get_height (Arena* self);
void arena_coords_move (ArenaCoords *self,
                        gint dx,
                        gint dy,
                        ArenaCoords* result);
static void arena_finalize (Arena * obj);
static GType arena_get_type_once (void);
gpointer arena_iterable_iterator_ref (gpointer instance);
void arena_iterable_iterator_unref (gpointer instance);
GParamSpec* arena_iterable_param_spec_iterator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void arena_iterable_value_set_iterator (GValue* value,
                                        gpointer v_object);
void arena_iterable_value_take_iterator (GValue* value,
                                         gpointer v_object);
gpointer arena_iterable_value_get_iterator (const GValue* value);
GType arena_iterable_iterator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterableIterator, arena_iterable_iterator_unref)
ArenaIterableIterator* arena_iterable_iterator (ArenaIterable* self);
ArenaIterableIterator* arena_iterable_iterator_new (ArenaIterable* iterable);
ArenaIterableIterator* arena_iterable_iterator_construct (GType object_type,
                                                          ArenaIterable* iterable);
ArenaCoords* arena_iterable_iterator_next_value (ArenaIterableIterator* self);
static void arena_iterable_iterator_finalize (ArenaIterableIterator * obj);
static GType arena_iterable_iterator_get_type_once (void);
static void arena_iterable_finalize (ArenaIterable * obj);
static GType arena_iterable_get_type_once (void);

static GType
object_type_get_type_once (void)
{
	static const GEnumValue values[] = {{OBJECT_TYPE_PLAYER, "OBJECT_TYPE_PLAYER", "player"}, {OBJECT_TYPE_HEAP, "OBJECT_TYPE_HEAP", "heap"}, {OBJECT_TYPE_ROBOT1, "OBJECT_TYPE_ROBOT1", "robot1"}, {OBJECT_TYPE_ROBOT2, "OBJECT_TYPE_ROBOT2", "robot2"}, {OBJECT_TYPE_NONE, "OBJECT_TYPE_NONE", "none"}, {0, NULL, NULL}};
	GType object_type_type_id;
	object_type_type_id = g_enum_register_static ("ObjectType", values);
	return object_type_type_id;
}

GType
object_type_get_type (void)
{
	static volatile gsize object_type_type_id__volatile = 0;
	if (g_once_init_enter (&object_type_type_id__volatile)) {
		GType object_type_type_id;
		object_type_type_id = object_type_get_type_once ();
		g_once_init_leave (&object_type_type_id__volatile, object_type_type_id);
	}
	return object_type_type_id__volatile;
}

static inline gpointer
arena_get_instance_private (Arena* self)
{
	return G_STRUCT_MEMBER_P (self, Arena_private_offset);
}

Arena*
arena_construct (GType object_type,
                 gint width,
                 gint height)
{
	Arena* self = NULL;
	ObjectType* _tmp0_;
	self = (Arena*) g_type_create_instance (object_type);
	self->priv->_width = width;
	self->priv->_height = height;
	_tmp0_ = g_new0 (ObjectType, width * height);
	self->priv->arena = (g_free (self->priv->arena), NULL);
	self->priv->arena = _tmp0_;
	self->priv->arena_length1 = width * height;
	self->priv->_arena_size_ = self->priv->arena_length1;
	arena_clear (self);
	return self;
}

Arena*
arena_new (gint width,
           gint height)
{
	return arena_construct (TYPE_ARENA, width, height);
}

void
arena_clear (Arena* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					i = i + 1;
					_tmp1_ = i;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->_width)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							ObjectType* _tmp4_;
							gint _tmp4__length1;
							if (!_tmp2_) {
								gint _tmp3_;
								j = j + 1;
								_tmp3_ = j;
							}
							_tmp2_ = FALSE;
							if (!(j < self->priv->_height)) {
								break;
							}
							_tmp4_ = self->priv->arena;
							_tmp4__length1 = self->priv->arena_length1;
							_tmp4_[i + (j * self->priv->_width)] = OBJECT_TYPE_NONE;
						}
					}
				}
			}
		}
	}
}

gboolean
arena_are_coords_valid (Arena* self,
                        ArenaCoords* coords)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ArenaCoords _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (coords != NULL, FALSE);
	_tmp3_ = *coords;
	if (_tmp3_.x >= 0) {
		ArenaCoords _tmp4_;
		_tmp4_ = *coords;
		_tmp2_ = _tmp4_.y >= 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		ArenaCoords _tmp5_;
		_tmp5_ = *coords;
		_tmp1_ = _tmp5_.x < self->priv->_width;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ArenaCoords _tmp6_;
		_tmp6_ = *coords;
		_tmp0_ = _tmp6_.y < self->priv->_height;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

ObjectType
arena_get (Arena* self,
           gint x,
           gint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ObjectType* _tmp3_;
	gint _tmp3__length1;
	ObjectType _tmp4_;
	ObjectType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (x < 0) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = y < 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = x >= self->priv->_width;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = y >= self->priv->_height;
	}
	if (_tmp0_) {
		result = OBJECT_TYPE_NONE;
		return result;
	}
	_tmp3_ = self->priv->arena;
	_tmp3__length1 = self->priv->arena_length1;
	_tmp4_ = _tmp3_[x + (y * self->priv->_width)];
	result = _tmp4_;
	return result;
}

void
arena_set (Arena* self,
           gint x,
           gint y,
           ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ObjectType* _tmp3_;
	gint _tmp3__length1;
	g_return_if_fail (self != NULL);
	if (x < 0) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = y < 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = x >= self->priv->_width;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = y >= self->priv->_height;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = self->priv->arena;
	_tmp3__length1 = self->priv->arena_length1;
	_tmp3_[x + (y * self->priv->_width)] = obj;
}

Arena*
arena_map (Arena* self,
           ArenaMapper mapper,
           gpointer mapper_target)
{
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	Arena* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = arena_new (self->priv->_width, self->priv->_height);
	new_arena = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					gint _tmp2_;
					i = i + 1;
					_tmp2_ = i;
				}
				_tmp1_ = FALSE;
				if (!(i < self->priv->_width)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							Arena* _tmp5_;
							ObjectType* _tmp6_;
							gint _tmp6__length1;
							ObjectType* _tmp7_;
							gint _tmp7__length1;
							ObjectType _tmp8_;
							if (!_tmp3_) {
								gint _tmp4_;
								j = j + 1;
								_tmp4_ = j;
							}
							_tmp3_ = FALSE;
							if (!(j < self->priv->_height)) {
								break;
							}
							_tmp5_ = new_arena;
							_tmp6_ = _tmp5_->priv->arena;
							_tmp6__length1 = _tmp5_->priv->arena_length1;
							_tmp7_ = self->priv->arena;
							_tmp7__length1 = self->priv->arena_length1;
							_tmp8_ = _tmp7_[i + (j * self->priv->_width)];
							_tmp6_[i + (j * self->priv->_width)] = mapper (_tmp8_, mapper_target);
						}
					}
				}
			}
		}
	}
	result = new_arena;
	return result;
}

gint
arena_count (Arena* self,
             GeePredicate predicate,
             gpointer predicate_target)
{
	gint _result_ = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_result_ = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					i = i + 1;
					_tmp1_ = i;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->_width)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							ObjectType* _tmp4_;
							gint _tmp4__length1;
							ObjectType _tmp5_;
							if (!_tmp2_) {
								gint _tmp3_;
								j = j + 1;
								_tmp3_ = j;
							}
							_tmp2_ = FALSE;
							if (!(j < self->priv->_height)) {
								break;
							}
							_tmp4_ = self->priv->arena;
							_tmp4__length1 = self->priv->arena_length1;
							_tmp5_ = _tmp4_[i + (j * self->priv->_width)];
							if (predicate ((gpointer) ((gintptr) _tmp5_), predicate_target)) {
								_result_ += 1;
							}
						}
					}
				}
			}
		}
	}
	result = _result_;
	return result;
}

ArenaIterable*
arena_iterate_from (Arena* self,
                    gint x,
                    gint y)
{
	ArenaIterable* _tmp0_;
	ArenaIterable* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = arena_iterable_new (self, x, y);
	result = _tmp0_;
	return result;
}

gint
arena_get_width (Arena* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_width;
	return result;
}

gint
arena_get_height (Arena* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_height;
	return result;
}

void
arena_coords_move (ArenaCoords *self,
                   gint dx,
                   gint dy,
                   ArenaCoords* result)
{
	ArenaCoords _tmp0_ = {0};
	memset (&_tmp0_, 0, sizeof (ArenaCoords));
	_tmp0_.x = (*self).x + dx;
	_tmp0_.y = (*self).y + dy;
	*result = _tmp0_;
	return;
}

ArenaCoords*
arena_coords_dup (const ArenaCoords* self)
{
	ArenaCoords* dup;
	dup = g_new0 (ArenaCoords, 1);
	memcpy (dup, self, sizeof (ArenaCoords));
	return dup;
}

void
arena_coords_free (ArenaCoords* self)
{
	g_free (self);
}

static GType
arena_coords_get_type_once (void)
{
	GType arena_coords_type_id;
	arena_coords_type_id = g_boxed_type_register_static ("ArenaCoords", (GBoxedCopyFunc) arena_coords_dup, (GBoxedFreeFunc) arena_coords_free);
	return arena_coords_type_id;
}

GType
arena_coords_get_type (void)
{
	static volatile gsize arena_coords_type_id__volatile = 0;
	if (g_once_init_enter (&arena_coords_type_id__volatile)) {
		GType arena_coords_type_id;
		arena_coords_type_id = arena_coords_get_type_once ();
		g_once_init_leave (&arena_coords_type_id__volatile, arena_coords_type_id);
	}
	return arena_coords_type_id__volatile;
}

static void
value_arena_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_arena_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		arena_unref (value->data[0].v_pointer);
	}
}

static void
value_arena_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = arena_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_arena_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_arena_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Arena * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = arena_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_arena_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Arena ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = arena_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_arena (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecArena* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ARENA), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_arena (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA), NULL);
	return value->data[0].v_pointer;
}

void
value_set_arena (GValue* value,
                 gpointer v_object)
{
	Arena * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		arena_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		arena_unref (old);
	}
}

void
value_take_arena (GValue* value,
                  gpointer v_object)
{
	Arena * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		arena_unref (old);
	}
}

static void
arena_class_init (ArenaClass * klass,
                  gpointer klass_data)
{
	arena_parent_class = g_type_class_peek_parent (klass);
	((ArenaClass *) klass)->finalize = arena_finalize;
	g_type_class_adjust_private_offset (klass, &Arena_private_offset);
}

static void
arena_instance_init (Arena * self,
                     gpointer klass)
{
	self->priv = arena_get_instance_private (self);
	self->ref_count = 1;
}

static void
arena_finalize (Arena * obj)
{
	Arena * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARENA, Arena);
	g_signal_handlers_destroy (self);
	self->priv->arena = (g_free (self->priv->arena), NULL);
}

static GType
arena_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_arena_init, value_arena_free_value, value_arena_copy_value, value_arena_peek_pointer, "p", value_arena_collect_value, "p", value_arena_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ArenaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arena_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Arena), 0, (GInstanceInitFunc) arena_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType arena_type_id;
	arena_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Arena", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Arena_private_offset = g_type_add_instance_private (arena_type_id, sizeof (ArenaPrivate));
	return arena_type_id;
}

GType
arena_get_type (void)
{
	static volatile gsize arena_type_id__volatile = 0;
	if (g_once_init_enter (&arena_type_id__volatile)) {
		GType arena_type_id;
		arena_type_id = arena_get_type_once ();
		g_once_init_leave (&arena_type_id__volatile, arena_type_id);
	}
	return arena_type_id__volatile;
}

gpointer
arena_ref (gpointer instance)
{
	Arena * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
arena_unref (gpointer instance)
{
	Arena * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ARENA_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
arena_iterable_get_instance_private (ArenaIterable* self)
{
	return G_STRUCT_MEMBER_P (self, ArenaIterable_private_offset);
}

static gpointer
_arena_ref0 (gpointer self)
{
	return self ? arena_ref (self) : NULL;
}

ArenaIterable*
arena_iterable_construct (GType object_type,
                          Arena* arena,
                          gint initial_x,
                          gint initial_y)
{
	ArenaIterable* self = NULL;
	Arena* _tmp0_;
	g_return_val_if_fail (arena != NULL, NULL);
	self = (ArenaIterable*) g_type_create_instance (object_type);
	_tmp0_ = _arena_ref0 (arena);
	_arena_unref0 (self->priv->arena);
	self->priv->arena = _tmp0_;
	self->priv->initial_x = initial_x;
	self->priv->initial_y = initial_y;
	return self;
}

ArenaIterable*
arena_iterable_new (Arena* arena,
                    gint initial_x,
                    gint initial_y)
{
	return arena_iterable_construct (TYPE_ARENA_ITERABLE, arena, initial_x, initial_y);
}

ArenaIterableIterator*
arena_iterable_iterator (ArenaIterable* self)
{
	ArenaIterableIterator* _tmp0_;
	ArenaIterableIterator* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = arena_iterable_iterator_new (self);
	result = _tmp0_;
	return result;
}

static inline gpointer
arena_iterable_iterator_get_instance_private (ArenaIterableIterator* self)
{
	return G_STRUCT_MEMBER_P (self, ArenaIterableIterator_private_offset);
}

ArenaIterableIterator*
arena_iterable_iterator_construct (GType object_type,
                                   ArenaIterable* iterable)
{
	ArenaIterableIterator* self = NULL;
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Arena* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	Arena* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	Arena* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	g_return_val_if_fail (iterable != NULL, NULL);
	self = (ArenaIterableIterator*) g_type_create_instance (object_type);
	_tmp0_ = iterable->priv->arena;
	_tmp1_ = arena_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->initial_position = iterable->priv->initial_x + (_tmp2_ * iterable->priv->initial_y);
	_tmp3_ = iterable->priv->arena;
	_tmp4_ = arena_get_width (_tmp3_);
	_tmp5_ = _tmp4_;
	self->priv->width = _tmp5_;
	_tmp6_ = iterable->priv->arena;
	_tmp7_ = arena_get_width (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = iterable->priv->arena;
	_tmp10_ = arena_get_height (_tmp9_);
	_tmp11_ = _tmp10_;
	self->priv->size = _tmp8_ * _tmp11_;
	self->priv->i = 0;
	return self;
}

ArenaIterableIterator*
arena_iterable_iterator_new (ArenaIterable* iterable)
{
	return arena_iterable_iterator_construct (ARENA_ITERABLE_TYPE_ITERATOR, iterable);
}

static gpointer
_arena_coords_dup0 (gpointer self)
{
	return self ? arena_coords_dup (self) : NULL;
}

ArenaCoords*
arena_iterable_iterator_next_value (ArenaIterableIterator* self)
{
	gint position = 0;
	ArenaCoords _result_ = {0};
	ArenaCoords _tmp0_ = {0};
	ArenaCoords* _tmp1_;
	ArenaCoords* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->priv->i >= self->priv->size) {
		result = NULL;
		return result;
	}
	position = (self->priv->initial_position + self->priv->i) % self->priv->size;
	memset (&_tmp0_, 0, sizeof (ArenaCoords));
	_tmp0_.x = position % self->priv->width;
	_tmp0_.y = position / self->priv->width;
	_result_ = _tmp0_;
	self->priv->i = self->priv->i + 1;
	_tmp1_ = _arena_coords_dup0 (&_result_);
	result = _tmp1_;
	return result;
}

static void
arena_iterable_value_iterator_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
arena_iterable_value_iterator_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		arena_iterable_iterator_unref (value->data[0].v_pointer);
	}
}

static void
arena_iterable_value_iterator_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = arena_iterable_iterator_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
arena_iterable_value_iterator_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
arena_iterable_value_iterator_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		ArenaIterableIterator * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = arena_iterable_iterator_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
arena_iterable_value_iterator_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	ArenaIterableIterator ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = arena_iterable_iterator_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
arena_iterable_param_spec_iterator (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	ArenaIterableParamSpecIterator* spec;
	g_return_val_if_fail (g_type_is_a (object_type, ARENA_ITERABLE_TYPE_ITERATOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
arena_iterable_value_get_iterator (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ARENA_ITERABLE_TYPE_ITERATOR), NULL);
	return value->data[0].v_pointer;
}

void
arena_iterable_value_set_iterator (GValue* value,
                                   gpointer v_object)
{
	ArenaIterableIterator * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ARENA_ITERABLE_TYPE_ITERATOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ARENA_ITERABLE_TYPE_ITERATOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		arena_iterable_iterator_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		arena_iterable_iterator_unref (old);
	}
}

void
arena_iterable_value_take_iterator (GValue* value,
                                    gpointer v_object)
{
	ArenaIterableIterator * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ARENA_ITERABLE_TYPE_ITERATOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ARENA_ITERABLE_TYPE_ITERATOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		arena_iterable_iterator_unref (old);
	}
}

static void
arena_iterable_iterator_class_init (ArenaIterableIteratorClass * klass,
                                    gpointer klass_data)
{
	arena_iterable_iterator_parent_class = g_type_class_peek_parent (klass);
	((ArenaIterableIteratorClass *) klass)->finalize = arena_iterable_iterator_finalize;
	g_type_class_adjust_private_offset (klass, &ArenaIterableIterator_private_offset);
}

static void
arena_iterable_iterator_instance_init (ArenaIterableIterator * self,
                                       gpointer klass)
{
	self->priv = arena_iterable_iterator_get_instance_private (self);
	self->ref_count = 1;
}

static void
arena_iterable_iterator_finalize (ArenaIterableIterator * obj)
{
	ArenaIterableIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIterator);
	g_signal_handlers_destroy (self);
}

static GType
arena_iterable_iterator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { arena_iterable_value_iterator_init, arena_iterable_value_iterator_free_value, arena_iterable_value_iterator_copy_value, arena_iterable_value_iterator_peek_pointer, "p", arena_iterable_value_iterator_collect_value, "p", arena_iterable_value_iterator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ArenaIterableIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arena_iterable_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ArenaIterableIterator), 0, (GInstanceInitFunc) arena_iterable_iterator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType arena_iterable_iterator_type_id;
	arena_iterable_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ArenaIterableIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ArenaIterableIterator_private_offset = g_type_add_instance_private (arena_iterable_iterator_type_id, sizeof (ArenaIterableIteratorPrivate));
	return arena_iterable_iterator_type_id;
}

GType
arena_iterable_iterator_get_type (void)
{
	static volatile gsize arena_iterable_iterator_type_id__volatile = 0;
	if (g_once_init_enter (&arena_iterable_iterator_type_id__volatile)) {
		GType arena_iterable_iterator_type_id;
		arena_iterable_iterator_type_id = arena_iterable_iterator_get_type_once ();
		g_once_init_leave (&arena_iterable_iterator_type_id__volatile, arena_iterable_iterator_type_id);
	}
	return arena_iterable_iterator_type_id__volatile;
}

gpointer
arena_iterable_iterator_ref (gpointer instance)
{
	ArenaIterableIterator * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
arena_iterable_iterator_unref (gpointer instance)
{
	ArenaIterableIterator * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ARENA_ITERABLE_ITERATOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
value_arena_iterable_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_arena_iterable_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		arena_iterable_unref (value->data[0].v_pointer);
	}
}

static void
value_arena_iterable_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = arena_iterable_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_arena_iterable_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_arena_iterable_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		ArenaIterable * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = arena_iterable_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_arena_iterable_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	ArenaIterable ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = arena_iterable_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_arena_iterable (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecArenaIterable* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ARENA_ITERABLE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_arena_iterable (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA_ITERABLE), NULL);
	return value->data[0].v_pointer;
}

void
value_set_arena_iterable (GValue* value,
                          gpointer v_object)
{
	ArenaIterable * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA_ITERABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA_ITERABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		arena_iterable_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		arena_iterable_unref (old);
	}
}

void
value_take_arena_iterable (GValue* value,
                           gpointer v_object)
{
	ArenaIterable * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA_ITERABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA_ITERABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		arena_iterable_unref (old);
	}
}

static void
arena_iterable_class_init (ArenaIterableClass * klass,
                           gpointer klass_data)
{
	arena_iterable_parent_class = g_type_class_peek_parent (klass);
	((ArenaIterableClass *) klass)->finalize = arena_iterable_finalize;
	g_type_class_adjust_private_offset (klass, &ArenaIterable_private_offset);
}

static void
arena_iterable_instance_init (ArenaIterable * self,
                              gpointer klass)
{
	self->priv = arena_iterable_get_instance_private (self);
	self->ref_count = 1;
}

static void
arena_iterable_finalize (ArenaIterable * obj)
{
	ArenaIterable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARENA_ITERABLE, ArenaIterable);
	g_signal_handlers_destroy (self);
	_arena_unref0 (self->priv->arena);
}

static GType
arena_iterable_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_arena_iterable_init, value_arena_iterable_free_value, value_arena_iterable_copy_value, value_arena_iterable_peek_pointer, "p", value_arena_iterable_collect_value, "p", value_arena_iterable_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ArenaIterableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arena_iterable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ArenaIterable), 0, (GInstanceInitFunc) arena_iterable_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType arena_iterable_type_id;
	arena_iterable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ArenaIterable", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ArenaIterable_private_offset = g_type_add_instance_private (arena_iterable_type_id, sizeof (ArenaIterablePrivate));
	return arena_iterable_type_id;
}

GType
arena_iterable_get_type (void)
{
	static volatile gsize arena_iterable_type_id__volatile = 0;
	if (g_once_init_enter (&arena_iterable_type_id__volatile)) {
		GType arena_iterable_type_id;
		arena_iterable_type_id = arena_iterable_get_type_once ();
		g_once_init_leave (&arena_iterable_type_id__volatile, arena_iterable_type_id);
	}
	return arena_iterable_type_id__volatile;
}

gpointer
arena_iterable_ref (gpointer instance)
{
	ArenaIterable * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
arena_iterable_unref (gpointer instance)
{
	ArenaIterable * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ARENA_ITERABLE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

