/* game-config.c generated by valac 0.48.15, the Vala compiler
 * generated from game-config.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define TYPE_GAME_CONFIG (game_config_get_type ())
typedef struct _GameConfig GameConfig;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define TYPE_GAME_CONFIGS (game_configs_get_type ())
#define GAME_CONFIGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_CONFIGS, GameConfigs))
#define GAME_CONFIGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_CONFIGS, GameConfigsClass))
#define IS_GAME_CONFIGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_CONFIGS))
#define IS_GAME_CONFIGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_CONFIGS))
#define GAME_CONFIGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_CONFIGS, GameConfigsClass))

typedef struct _GameConfigs GameConfigs;
typedef struct _GameConfigsClass GameConfigsClass;
typedef struct _GameConfigsPrivate GameConfigsPrivate;
#define _game_configs_unref0(var) ((var == NULL) ? NULL : (var = (game_configs_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _game_config_free0(var) ((var == NULL) ? NULL : (var = (game_config_free (var), NULL)))
typedef struct _ParamSpecGameConfigs ParamSpecGameConfigs;

struct _GameConfig {
	gchar* description;
	gint initial_type1;
	gint initial_type2;
	gint increment_type1;
	gint increment_type2;
	gint maximum_type1;
	gint maximum_type2;
	gint score_type1;
	gint score_type2;
	gint score_type1_waiting;
	gint score_type2_waiting;
	gint score_type1_splatted;
	gint score_type2_splatted;
	gint num_robots_per_safe;
	gint safe_score_boundary;
	gint initial_safe_teleports;
	gint free_safe_teleports;
	gint max_safe_teleports;
	gboolean moveable_heaps;
};

struct _GameConfigs {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameConfigsPrivate * priv;
};

struct _GameConfigsClass {
	GTypeClass parent_class;
	void (*finalize) (GameConfigs *self);
};

struct _GameConfigsPrivate {
	GeeArrayList* game_configs;
};

struct _ParamSpecGameConfigs {
	GParamSpec parent_instance;
};

static gint GameConfigs_private_offset;
static gpointer game_configs_parent_class = NULL;

GType game_config_get_type (void) G_GNUC_CONST;
GameConfig* game_config_dup (const GameConfig* self);
void game_config_free (GameConfig* self);
void game_config_copy (const GameConfig* self,
                       GameConfig* dest);
void game_config_destroy (GameConfig* self);
gchar* game_config_name (GameConfig *self);
void game_config_from_file (const gchar* filename,
                            GameConfig* result,
                            GError** error);
gpointer game_configs_ref (gpointer instance);
void game_configs_unref (gpointer instance);
GParamSpec* param_spec_game_configs (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_game_configs (GValue* value,
                             gpointer v_object);
void value_take_game_configs (GValue* value,
                              gpointer v_object);
gpointer value_get_game_configs (const GValue* value);
GType game_configs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameConfigs, game_configs_unref)
GameConfigs* game_configs_new_load (GError** error);
GameConfigs* game_configs_construct_load (GType object_type,
                                          GError** error);
guint game_configs_count (GameConfigs* self);
GameConfig* game_configs_get (GameConfigs* self,
                              guint n);
gchar* game_configs_get_name (GameConfigs* self,
                              guint n);
GameConfig* game_configs_find_by_name (GameConfigs* self,
                                       const gchar* name);
GameConfigs* game_configs_new (void);
GameConfigs* game_configs_construct (GType object_type);
static void game_configs_finalize (GameConfigs * obj);
static GType game_configs_get_type_once (void);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp7_);
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp7_);
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
game_config_name (GameConfig *self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
	_tmp0_ = (*self).description;
	_tmp1_ = string_replace (_tmp0_, "_", " ");
	result = _tmp1_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

void
game_config_from_file (const gchar* filename,
                       GameConfig* result,
                       GError** error)
{
	GameConfig gcfg = {0};
	gchar* _tmp0_;
	GameConfig _tmp1_;
	const gchar* _tmp2_;
	GRegex* line_regex = NULL;
	GRegex* _tmp10_;
	GFile* file = NULL;
	GFile* _tmp11_;
	GFileInputStream* _tmp12_ = NULL;
	GFile* _tmp13_;
	GFileInputStream* _tmp14_;
	GDataInputStream* dis = NULL;
	GDataInputStream* _tmp15_;
	gchar* line = NULL;
	guint pflag = 0U;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (filename != NULL);
	memset (&gcfg, 0, sizeof (GameConfig));
	_tmp0_ = g_path_get_basename (filename);
	_g_free0 (gcfg.description);
	gcfg.description = _tmp0_;
	_tmp1_ = gcfg;
	_tmp2_ = _tmp1_.description;
	if (g_str_has_suffix (_tmp2_, ".cfg")) {
		GameConfig _tmp3_;
		const gchar* _tmp4_;
		GameConfig _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		_tmp3_ = gcfg;
		_tmp4_ = _tmp3_.description;
		_tmp5_ = gcfg;
		_tmp6_ = _tmp5_.description;
		_tmp7_ = strlen (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = string_substring (_tmp4_, (glong) 0, (glong) (_tmp8_ - 4));
		_g_free0 (gcfg.description);
		gcfg.description = _tmp9_;
	}
	_tmp10_ = g_regex_new ("^(\\w+)\\s*=\\s*(\\d+)", 0, 0, &_inner_error0_);
	line_regex = _tmp10_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		game_config_destroy (&gcfg);
		return;
	}
	_tmp11_ = g_file_new_for_path (filename);
	file = _tmp11_;
	_tmp13_ = file;
	_tmp14_ = g_file_read (_tmp13_, NULL, &_inner_error0_);
	_tmp12_ = _tmp14_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (file);
		_g_regex_unref0 (line_regex);
		game_config_destroy (&gcfg);
		return;
	}
	_tmp15_ = g_data_input_stream_new ((GInputStream*) _tmp12_);
	dis = _tmp15_;
	pflag = (guint) 0;
	while (TRUE) {
		gchar* _tmp16_ = NULL;
		GDataInputStream* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		GMatchInfo* match_info = NULL;
		GRegex* _tmp21_;
		const gchar* _tmp22_;
		GMatchInfo* _tmp23_ = NULL;
		gboolean _tmp24_;
		gchar* key = NULL;
		GMatchInfo* _tmp25_;
		gchar* _tmp26_;
		gint val = 0;
		GMatchInfo* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gint _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		_tmp17_ = dis;
		_tmp18_ = g_data_input_stream_read_line (_tmp17_, NULL, NULL, &_inner_error0_);
		_tmp16_ = _tmp18_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (line);
			_g_object_unref0 (dis);
			_g_object_unref0 (_tmp12_);
			_g_object_unref0 (file);
			_g_regex_unref0 (line_regex);
			game_config_destroy (&gcfg);
			return;
		}
		_tmp19_ = _tmp16_;
		_tmp16_ = NULL;
		_g_free0 (line);
		line = _tmp19_;
		_tmp20_ = line;
		if (!(_tmp20_ != NULL)) {
			_g_free0 (_tmp16_);
			break;
		}
		_tmp21_ = line_regex;
		_tmp22_ = line;
		_tmp24_ = g_regex_match (_tmp21_, _tmp22_, 0, &_tmp23_);
		_g_match_info_unref0 (match_info);
		match_info = _tmp23_;
		if (!_tmp24_) {
			_g_match_info_unref0 (match_info);
			_g_free0 (_tmp16_);
			continue;
		}
		_tmp25_ = match_info;
		_tmp26_ = g_match_info_fetch (_tmp25_, 1);
		key = _tmp26_;
		_tmp27_ = match_info;
		_tmp28_ = g_match_info_fetch (_tmp27_, 2);
		_tmp29_ = _tmp28_;
		_tmp30_ = atoi (_tmp29_);
		_g_free0 (_tmp29_);
		val = _tmp30_;
		_tmp31_ = key;
		if (g_strcmp0 (_tmp31_, "initial_type1") == 0) {
			gcfg.initial_type1 = val;
			pflag |= (guint) 0x00000001;
		}
		_tmp32_ = key;
		if (g_strcmp0 (_tmp32_, "initial_type2") == 0) {
			gcfg.initial_type2 = val;
			pflag |= (guint) 0x00000002;
		}
		_tmp33_ = key;
		if (g_strcmp0 (_tmp33_, "increment_type1") == 0) {
			gcfg.increment_type1 = val;
			pflag |= (guint) 0x00000004;
		}
		_tmp34_ = key;
		if (g_strcmp0 (_tmp34_, "increment_type2") == 0) {
			gcfg.increment_type2 = val;
			pflag |= (guint) 0x00000008;
		}
		_tmp35_ = key;
		if (g_strcmp0 (_tmp35_, "maximum_type1") == 0) {
			gcfg.maximum_type1 = val;
			pflag |= (guint) 0x00000010;
		}
		_tmp36_ = key;
		if (g_strcmp0 (_tmp36_, "maximum_type2") == 0) {
			gcfg.maximum_type2 = val;
			pflag |= (guint) 0x00000020;
		}
		_tmp37_ = key;
		if (g_strcmp0 (_tmp37_, "score_type1") == 0) {
			gcfg.score_type1 = val;
			pflag |= (guint) 0x00000040;
		}
		_tmp38_ = key;
		if (g_strcmp0 (_tmp38_, "score_type2") == 0) {
			gcfg.score_type2 = val;
			pflag |= (guint) 0x00000080;
		}
		_tmp39_ = key;
		if (g_strcmp0 (_tmp39_, "score_type1_waiting") == 0) {
			gcfg.score_type1_waiting = val;
			pflag |= (guint) 0x00000100;
		}
		_tmp40_ = key;
		if (g_strcmp0 (_tmp40_, "score_type2_waiting") == 0) {
			gcfg.score_type2_waiting = val;
			pflag |= (guint) 0x00000200;
		}
		_tmp41_ = key;
		if (g_strcmp0 (_tmp41_, "score_type1_splatted") == 0) {
			gcfg.score_type1_splatted = val;
			pflag |= (guint) 0x00000400;
		}
		_tmp42_ = key;
		if (g_strcmp0 (_tmp42_, "score_type2_splatted") == 0) {
			gcfg.score_type2_splatted = val;
			pflag |= (guint) 0x00000800;
		}
		_tmp43_ = key;
		if (g_strcmp0 (_tmp43_, "num_robots_per_safe") == 0) {
			gcfg.num_robots_per_safe = val;
			pflag |= (guint) 0x00001000;
		}
		_tmp44_ = key;
		if (g_strcmp0 (_tmp44_, "safe_score_boundary") == 0) {
			gcfg.safe_score_boundary = val;
			pflag |= (guint) 0x00002000;
		}
		_tmp45_ = key;
		if (g_strcmp0 (_tmp45_, "max_safe_teleports") == 0) {
			gcfg.max_safe_teleports = val;
			pflag |= (guint) 0x00004000;
		}
		_tmp46_ = key;
		if (g_strcmp0 (_tmp46_, "initial_safe_teleports") == 0) {
			gcfg.initial_safe_teleports = val;
			pflag |= (guint) 0x00008000;
		}
		_tmp47_ = key;
		if (g_strcmp0 (_tmp47_, "free_safe_teleports") == 0) {
			gcfg.free_safe_teleports = val;
			pflag |= (guint) 0x00010000;
		}
		_tmp48_ = key;
		if (g_strcmp0 (_tmp48_, "moveable_heaps") == 0) {
			gcfg.moveable_heaps = val != 0;
			pflag |= (guint) 0x00020000;
		}
		_g_free0 (key);
		_g_match_info_unref0 (match_info);
		_g_free0 (_tmp16_);
	}
	if (pflag != ((guint) 0x0003ffff)) {
		GError* _tmp49_;
		_tmp49_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, "Bad game config file.");
		_inner_error0_ = _tmp49_;
		g_propagate_error (error, _inner_error0_);
		_g_free0 (line);
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp12_);
		_g_object_unref0 (file);
		_g_regex_unref0 (line_regex);
		game_config_destroy (&gcfg);
		return;
	}
	*result = gcfg;
	_g_free0 (line);
	_g_object_unref0 (dis);
	_g_object_unref0 (_tmp12_);
	_g_object_unref0 (file);
	_g_regex_unref0 (line_regex);
	return;
}

void
game_config_copy (const GameConfig* self,
                  GameConfig* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = (*self).description;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).description);
	(*dest).description = _tmp1_;
	(*dest).initial_type1 = (*self).initial_type1;
	(*dest).initial_type2 = (*self).initial_type2;
	(*dest).increment_type1 = (*self).increment_type1;
	(*dest).increment_type2 = (*self).increment_type2;
	(*dest).maximum_type1 = (*self).maximum_type1;
	(*dest).maximum_type2 = (*self).maximum_type2;
	(*dest).score_type1 = (*self).score_type1;
	(*dest).score_type2 = (*self).score_type2;
	(*dest).score_type1_waiting = (*self).score_type1_waiting;
	(*dest).score_type2_waiting = (*self).score_type2_waiting;
	(*dest).score_type1_splatted = (*self).score_type1_splatted;
	(*dest).score_type2_splatted = (*self).score_type2_splatted;
	(*dest).num_robots_per_safe = (*self).num_robots_per_safe;
	(*dest).safe_score_boundary = (*self).safe_score_boundary;
	(*dest).initial_safe_teleports = (*self).initial_safe_teleports;
	(*dest).free_safe_teleports = (*self).free_safe_teleports;
	(*dest).max_safe_teleports = (*self).max_safe_teleports;
	(*dest).moveable_heaps = (*self).moveable_heaps;
}

void
game_config_destroy (GameConfig* self)
{
	_g_free0 ((*self).description);
}

GameConfig*
game_config_dup (const GameConfig* self)
{
	GameConfig* dup;
	dup = g_new0 (GameConfig, 1);
	game_config_copy (self, dup);
	return dup;
}

void
game_config_free (GameConfig* self)
{
	game_config_destroy (self);
	g_free (self);
}

static GType
game_config_get_type_once (void)
{
	GType game_config_type_id;
	game_config_type_id = g_boxed_type_register_static ("GameConfig", (GBoxedCopyFunc) game_config_dup, (GBoxedFreeFunc) game_config_free);
	return game_config_type_id;
}

GType
game_config_get_type (void)
{
	static volatile gsize game_config_type_id__volatile = 0;
	if (g_once_init_enter (&game_config_type_id__volatile)) {
		GType game_config_type_id;
		game_config_type_id = game_config_get_type_once ();
		g_once_init_leave (&game_config_type_id__volatile, game_config_type_id);
	}
	return game_config_type_id__volatile;
}

static inline gpointer
game_configs_get_instance_private (GameConfigs* self)
{
	return G_STRUCT_MEMBER_P (self, GameConfigs_private_offset);
}

GameConfigs*
game_configs_construct_load (GType object_type,
                             GError** error)
{
	GameConfigs* self = NULL;
	gchar* dname = NULL;
	gchar* _tmp0_;
	GDir* dir = NULL;
	const gchar* _tmp1_;
	GDir* _tmp2_;
	GeeArrayList* _tmp3_;
	gchar* filename = NULL;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GError* _inner_error0_ = NULL;
	self = (GameConfigs*) g_type_create_instance (object_type);
	_tmp0_ = g_build_filename (DATA_DIRECTORY, "games", NULL);
	dname = _tmp0_;
	_tmp1_ = dname;
	_tmp2_ = g_dir_open (_tmp1_, (guint) 0, &_inner_error0_);
	dir = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (dname);
		_game_configs_unref0 (self);
		return NULL;
	}
	_tmp3_ = gee_array_list_new (TYPE_GAME_CONFIG, (GBoxedCopyFunc) game_config_dup, (GDestroyNotify) game_config_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->game_configs);
	self->priv->game_configs = _tmp3_;
	while (TRUE) {
		GDir* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* fullname = NULL;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp4_ = dir;
		_tmp5_ = g_dir_read_name (_tmp4_);
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (filename);
		filename = _tmp6_;
		_tmp7_ = filename;
		if (!(_tmp7_ != NULL)) {
			break;
		}
		_tmp8_ = filename;
		if (!g_str_has_suffix (_tmp8_, ".cfg")) {
			continue;
		}
		_tmp9_ = dname;
		_tmp10_ = filename;
		_tmp11_ = g_build_filename (_tmp9_, _tmp10_, NULL);
		fullname = _tmp11_;
		{
			GameConfig gcfg = {0};
			const gchar* _tmp12_;
			GameConfig _tmp13_ = {0};
			GeeArrayList* _tmp14_;
			GameConfig _tmp15_;
			_tmp12_ = fullname;
			game_config_from_file (_tmp12_, &_tmp13_, &_inner_error0_);
			gcfg = _tmp13_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp14_ = self->priv->game_configs;
			_tmp15_ = gcfg;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, &_tmp15_);
			game_config_destroy (&gcfg);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp16_ = e;
			_tmp17_ = _tmp16_->message;
			g_warning ("game-config.vala:168: %s", _tmp17_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (fullname);
			_g_free0 (filename);
			_g_dir_close0 (dir);
			_g_free0 (dname);
			_game_configs_unref0 (self);
			return NULL;
		}
		_g_free0 (fullname);
	}
	_tmp18_ = self->priv->game_configs;
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
	_tmp20_ = _tmp19_;
	if (_tmp20_ == 0) {
		GError* _tmp21_;
		_tmp21_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_NOENT, "No game config was found.");
		_inner_error0_ = _tmp21_;
		g_propagate_error (error, _inner_error0_);
		_g_free0 (filename);
		_g_dir_close0 (dir);
		_g_free0 (dname);
		_game_configs_unref0 (self);
		return NULL;
	}
	_g_free0 (filename);
	_g_dir_close0 (dir);
	_g_free0 (dname);
	return self;
}

GameConfigs*
game_configs_new_load (GError** error)
{
	return game_configs_construct_load (TYPE_GAME_CONFIGS, error);
}

guint
game_configs_count (GameConfigs* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->game_configs;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (guint) _tmp2_;
	return result;
}

GameConfig*
game_configs_get (GameConfigs* self,
                  guint n)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GameConfig* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->game_configs;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (n < ((guint) _tmp2_)) {
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
		_tmp3_ = self->priv->game_configs;
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, (gint) n);
		result = (GameConfig*) _tmp4_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}

gchar*
game_configs_get_name (GameConfigs* self,
                       guint n)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->game_configs;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (n < ((guint) _tmp2_)) {
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
		GameConfig* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp3_ = self->priv->game_configs;
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, (gint) n);
		_tmp5_ = (GameConfig*) _tmp4_;
		_tmp6_ = (*_tmp5_).description;
		_tmp7_ = string_replace (_tmp6_, "_", " ");
		_tmp8_ = _tmp7_;
		_game_config_free0 (_tmp5_);
		result = _tmp8_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}

GameConfig*
game_configs_find_by_name (GameConfigs* self,
                           const gchar* name)
{
	GameConfig* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gboolean _tmp5_ = FALSE;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				GameConfig* _tmp8_;
				const gchar* _tmp9_;
				gboolean _tmp10_;
				if (!_tmp0_) {
					gint _tmp1_;
					i = i + 1;
					_tmp1_ = i;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->game_configs;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp6_ = self->priv->game_configs;
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, i);
				_tmp8_ = (GameConfig*) _tmp7_;
				_tmp9_ = (*_tmp8_).description;
				_tmp10_ = g_strcmp0 (_tmp9_, name) == 0;
				_game_config_free0 (_tmp8_);
				if (_tmp10_) {
					_tmp5_ = TRUE;
				} else {
					GeeArrayList* _tmp11_;
					gpointer _tmp12_;
					GameConfig* _tmp13_;
					GameConfig _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					_tmp11_ = self->priv->game_configs;
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, i);
					_tmp13_ = (GameConfig*) _tmp12_;
					_tmp14_ = *_tmp13_;
					_tmp15_ = game_config_name (&_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp5_ = g_strcmp0 (_tmp16_, name) == 0;
					_g_free0 (_tmp16_);
					_game_config_free0 (_tmp13_);
				}
				if (_tmp5_) {
					GeeArrayList* _tmp17_;
					gpointer _tmp18_;
					_tmp17_ = self->priv->game_configs;
					_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, i);
					result = (GameConfig*) _tmp18_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}

GameConfigs*
game_configs_construct (GType object_type)
{
	GameConfigs* self = NULL;
	self = (GameConfigs*) g_type_create_instance (object_type);
	return self;
}

GameConfigs*
game_configs_new (void)
{
	return game_configs_construct (TYPE_GAME_CONFIGS);
}

static void
value_game_configs_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_game_configs_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		game_configs_unref (value->data[0].v_pointer);
	}
}

static void
value_game_configs_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = game_configs_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_game_configs_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_game_configs_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GameConfigs * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = game_configs_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_game_configs_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	GameConfigs ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = game_configs_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_game_configs (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecGameConfigs* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_GAME_CONFIGS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_game_configs (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME_CONFIGS), NULL);
	return value->data[0].v_pointer;
}

void
value_set_game_configs (GValue* value,
                        gpointer v_object)
{
	GameConfigs * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME_CONFIGS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME_CONFIGS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		game_configs_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		game_configs_unref (old);
	}
}

void
value_take_game_configs (GValue* value,
                         gpointer v_object)
{
	GameConfigs * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME_CONFIGS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME_CONFIGS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		game_configs_unref (old);
	}
}

static void
game_configs_class_init (GameConfigsClass * klass,
                         gpointer klass_data)
{
	game_configs_parent_class = g_type_class_peek_parent (klass);
	((GameConfigsClass *) klass)->finalize = game_configs_finalize;
	g_type_class_adjust_private_offset (klass, &GameConfigs_private_offset);
}

static void
game_configs_instance_init (GameConfigs * self,
                            gpointer klass)
{
	self->priv = game_configs_get_instance_private (self);
	self->ref_count = 1;
}

static void
game_configs_finalize (GameConfigs * obj)
{
	GameConfigs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_CONFIGS, GameConfigs);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->game_configs);
}

static GType
game_configs_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_game_configs_init, value_game_configs_free_value, value_game_configs_copy_value, value_game_configs_peek_pointer, "p", value_game_configs_collect_value, "p", value_game_configs_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameConfigsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_configs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameConfigs), 0, (GInstanceInitFunc) game_configs_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_configs_type_id;
	game_configs_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameConfigs", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GameConfigs_private_offset = g_type_add_instance_private (game_configs_type_id, sizeof (GameConfigsPrivate));
	return game_configs_type_id;
}

GType
game_configs_get_type (void)
{
	static volatile gsize game_configs_type_id__volatile = 0;
	if (g_once_init_enter (&game_configs_type_id__volatile)) {
		GType game_configs_type_id;
		game_configs_type_id = game_configs_get_type_once ();
		g_once_init_leave (&game_configs_type_id__volatile, game_configs_type_id);
	}
	return game_configs_type_id__volatile;
}

gpointer
game_configs_ref (gpointer instance)
{
	GameConfigs * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
game_configs_unref (gpointer instance)
{
	GameConfigs * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GAME_CONFIGS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

