/* properties.c generated by valac 0.48.15, the Vala compiler
 * generated from properties.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#define TYPE_PROPERTIES (properties_get_type ())
#define PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTIES, Properties))
#define PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTIES, PropertiesClass))
#define IS_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTIES))
#define IS_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTIES))
#define PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTIES, PropertiesClass))

typedef struct _Properties Properties;
typedef struct _PropertiesClass PropertiesClass;
typedef struct _PropertiesPrivate PropertiesPrivate;

#define PROPERTIES_TYPE_KEYS (properties_keys_get_type ())
#define PROPERTIES_KEYS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PROPERTIES_TYPE_KEYS, PropertiesKeys))
#define PROPERTIES_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PROPERTIES_TYPE_KEYS, PropertiesKeysClass))
#define PROPERTIES_IS_KEYS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PROPERTIES_TYPE_KEYS))
#define PROPERTIES_IS_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PROPERTIES_TYPE_KEYS))
#define PROPERTIES_KEYS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PROPERTIES_TYPE_KEYS, PropertiesKeysClass))

typedef struct _PropertiesKeys PropertiesKeys;
typedef struct _PropertiesKeysClass PropertiesKeysClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _properties_keys_unref0(var) ((var == NULL) ? NULL : (var = (properties_keys_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PropertiesKeysPrivate PropertiesKeysPrivate;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _PropertiesParamSpecKeys PropertiesParamSpecKeys;
typedef struct _ParamSpecProperties ParamSpecProperties;
enum  {
	PROPERTIES_CHANGED_SIGNAL,
	PROPERTIES_NUM_SIGNALS
};
static guint properties_signals[PROPERTIES_NUM_SIGNALS] = {0};

struct _Properties {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PropertiesPrivate * priv;
};

struct _PropertiesClass {
	GTypeClass parent_class;
	void (*finalize) (Properties *self);
};

struct _PropertiesPrivate {
	GSettings* settings;
	PropertiesKeys* _keys;
	gulong notify_handler_id;
};

struct _PropertiesKeys {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PropertiesKeysPrivate * priv;
};

struct _PropertiesKeysClass {
	GTypeClass parent_class;
	void (*finalize) (PropertiesKeys *self);
};

struct _PropertiesKeysPrivate {
	GSettings* settings;
};

struct _PropertiesParamSpecKeys {
	GParamSpec parent_instance;
};

struct _ParamSpecProperties {
	GParamSpec parent_instance;
};

static gint Properties_private_offset;
static gpointer properties_parent_class = NULL;
static gint PropertiesKeys_private_offset;
static gpointer properties_keys_parent_class = NULL;

gpointer properties_ref (gpointer instance);
void properties_unref (gpointer instance);
GParamSpec* param_spec_properties (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_properties (GValue* value,
                           gpointer v_object);
void value_take_properties (GValue* value,
                            gpointer v_object);
gpointer value_get_properties (const GValue* value);
GType properties_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Properties, properties_unref)
gpointer properties_keys_ref (gpointer instance);
void properties_keys_unref (gpointer instance);
GParamSpec* properties_param_spec_keys (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void properties_value_set_keys (GValue* value,
                                gpointer v_object);
void properties_value_take_keys (GValue* value,
                                 gpointer v_object);
gpointer properties_value_get_keys (const GValue* value);
GType properties_keys_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertiesKeys, properties_keys_unref)
#define PROPERTIES_KEY_BACKGROUND_COLOR "background-color"
#define PROPERTIES_KEY_CONFIGURATION "configuration"
#define PROPERTIES_KEY_ENABLE_SOUND "enable-sound"
#define PROPERTIES_KEY_SAFE_MOVES "use-safe-moves"
#define PROPERTIES_KEY_SHOW_TOOLBAR "show-toolbar"
#define PROPERTIES_KEY_SUPER_SAFE_MOVES "use-super-safe-moves"
#define PROPERTIES_KEY_THEME "theme"
Properties* properties_new (GSettings* settings);
Properties* properties_construct (GType object_type,
                                  GSettings* settings);
PropertiesKeys* properties_keys_new (GSettings* settings);
PropertiesKeys* properties_keys_construct (GType object_type,
                                           GSettings* settings);
static void __lambda6_ (Properties* self);
static void ___lambda6__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
gboolean properties_get_safe_moves (Properties* self);
void properties_set_safe_moves (Properties* self,
                                gboolean value);
gboolean properties_get_super_safe_moves (Properties* self);
void properties_set_super_safe_moves (Properties* self,
                                      gboolean value);
gboolean properties_get_sound (Properties* self);
void properties_set_sound (Properties* self,
                           gboolean value);
gboolean properties_get_show_toolbar (Properties* self);
void properties_set_show_toolbar (Properties* self,
                                  gboolean value);
void properties_get_bgcolour (Properties* self,
                              GdkRGBA * result);
void string_to_rgba (const gchar* color,
                     GdkRGBA* result);
void properties_set_bgcolour (Properties* self,
                              GdkRGBA * value);
gchar* rgba_to_string (GdkRGBA* color);
gchar* properties_get_selected_config (Properties* self);
void properties_set_selected_config (Properties* self,
                                     const gchar* value);
PropertiesKeys* properties_get_keys (Properties* self);
gchar* properties_get_theme (Properties* self);
void properties_set_theme (Properties* self,
                           const gchar* value);
guint properties_keys_get (PropertiesKeys* self,
                           guint index);
gint properties_keys_get_size (PropertiesKeys* self);
void properties_keys_set (PropertiesKeys* self,
                          guint index,
                          guint keyval);
guint properties_keys_get_default (PropertiesKeys* self,
                                   guint index);
void properties_keys_reset (PropertiesKeys* self,
                            guint index);
void properties_keys_reset_all (PropertiesKeys* self);
static void properties_keys_finalize (PropertiesKeys * obj);
static GType properties_keys_get_type_once (void);
static void properties_finalize (Properties * obj);
static GType properties_get_type_once (void);

static inline gpointer
properties_get_instance_private (Properties* self)
{
	return G_STRUCT_MEMBER_P (self, Properties_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda6_ (Properties* self)
{
	g_signal_emit (self, properties_signals[PROPERTIES_CHANGED_SIGNAL], 0);
}

static void
___lambda6__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
	__lambda6_ ((Properties*) self);
}

Properties*
properties_construct (GType object_type,
                      GSettings* settings)
{
	Properties* self = NULL;
	GSettings* _tmp0_;
	PropertiesKeys* _tmp1_;
	gulong _tmp2_;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (Properties*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = properties_keys_new (settings);
	_properties_keys_unref0 (self->priv->_keys);
	self->priv->_keys = _tmp1_;
	_tmp2_ = g_signal_connect (settings, "changed", (GCallback) ___lambda6__g_settings_changed, self);
	self->priv->notify_handler_id = _tmp2_;
	return self;
}

Properties*
properties_new (GSettings* settings)
{
	return properties_construct (TYPE_PROPERTIES, settings);
}

gboolean
properties_get_safe_moves (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_SAFE_MOVES);
	return result;
}

void
properties_set_safe_moves (Properties* self,
                           gboolean value)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_SAFE_MOVES, value);
}

gboolean
properties_get_super_safe_moves (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_SUPER_SAFE_MOVES);
	return result;
}

void
properties_set_super_safe_moves (Properties* self,
                                 gboolean value)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_SUPER_SAFE_MOVES, value);
}

gboolean
properties_get_sound (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_ENABLE_SOUND);
	return result;
}

void
properties_set_sound (Properties* self,
                      gboolean value)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_ENABLE_SOUND, value);
}

gboolean
properties_get_show_toolbar (Properties* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	result = g_settings_get_boolean (_tmp0_, PROPERTIES_KEY_SHOW_TOOLBAR);
	return result;
}

void
properties_set_show_toolbar (Properties* self,
                             gboolean value)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_set_boolean (_tmp0_, PROPERTIES_KEY_SHOW_TOOLBAR, value);
}

void
properties_get_bgcolour (Properties* self,
                         GdkRGBA * result)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_string (_tmp0_, PROPERTIES_KEY_BACKGROUND_COLOR);
	_tmp2_ = _tmp1_;
	string_to_rgba (_tmp2_, &_tmp3_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	*result = _tmp4_;
	return;
}

void
properties_set_bgcolour (Properties* self,
                         GdkRGBA * value)
{
	GSettings* _tmp0_;
	GdkRGBA _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = *value;
	_tmp2_ = rgba_to_string (&_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_string (_tmp0_, PROPERTIES_KEY_BACKGROUND_COLOR, _tmp3_);
	_g_free0 (_tmp3_);
}

gchar*
properties_get_selected_config (Properties* self)
{
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_string (_tmp0_, PROPERTIES_KEY_CONFIGURATION);
	result = _tmp1_;
	return result;
}

void
properties_set_selected_config (Properties* self,
                                const gchar* value)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_set_string (_tmp0_, PROPERTIES_KEY_CONFIGURATION, value);
}

PropertiesKeys*
properties_get_keys (Properties* self)
{
	PropertiesKeys* result;
	PropertiesKeys* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_keys;
	result = _tmp0_;
	return result;
}

gchar*
properties_get_theme (Properties* self)
{
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_string (_tmp0_, PROPERTIES_KEY_THEME);
	result = _tmp1_;
	return result;
}

void
properties_set_theme (Properties* self,
                      const gchar* value)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_set_string (_tmp0_, PROPERTIES_KEY_THEME, value);
}

static inline gpointer
properties_keys_get_instance_private (PropertiesKeys* self)
{
	return G_STRUCT_MEMBER_P (self, PropertiesKeys_private_offset);
}

PropertiesKeys*
properties_keys_construct (GType object_type,
                           GSettings* settings)
{
	PropertiesKeys* self = NULL;
	GSettings* _tmp0_;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (PropertiesKeys*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	return self;
}

PropertiesKeys*
properties_keys_new (GSettings* settings)
{
	return properties_keys_construct (PROPERTIES_TYPE_KEYS, settings);
}

guint
properties_keys_get (PropertiesKeys* self,
                     guint index)
{
	gint _tmp0_;
	gint _tmp1_;
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = properties_keys_get_size (self);
	_tmp1_ = _tmp0_;
	if (index < ((guint) _tmp1_)) {
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		guint _tmp5_;
		_tmp2_ = self->priv->settings;
		_tmp3_ = g_strdup_printf ("key%02u", index);
		_tmp4_ = _tmp3_;
		_tmp5_ = (guint) g_settings_get_int (_tmp2_, _tmp4_);
		_g_free0 (_tmp4_);
		result = _tmp5_;
		return result;
	} else {
		result = (guint) 0;
		return result;
	}
}

void
properties_keys_set (PropertiesKeys* self,
                     guint index,
                     guint keyval)
{
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = properties_keys_get_size (self);
	_tmp1_ = _tmp0_;
	if (index < ((guint) _tmp1_)) {
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = self->priv->settings;
		_tmp3_ = g_strdup_printf ("key%02u", index);
		_tmp4_ = _tmp3_;
		g_settings_set_int (_tmp2_, _tmp4_, (gint) keyval);
		_g_free0 (_tmp4_);
	}
}

guint
properties_keys_get_default (PropertiesKeys* self,
                             guint index)
{
	gint _tmp0_;
	gint _tmp1_;
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = properties_keys_get_size (self);
	_tmp1_ = _tmp0_;
	if (index < ((guint) _tmp1_)) {
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		guint _tmp7_;
		_tmp2_ = self->priv->settings;
		_tmp3_ = g_strdup_printf ("key%02u", index);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_settings_get_default_value (_tmp2_, _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = (guint) g_variant_get_int32 (_tmp6_);
		_g_variant_unref0 (_tmp6_);
		_g_free0 (_tmp4_);
		result = _tmp7_;
		return result;
	} else {
		result = (guint) 0;
		return result;
	}
}

void
properties_keys_reset (PropertiesKeys* self,
                       guint index)
{
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = properties_keys_get_size (self);
	_tmp1_ = _tmp0_;
	if (index < ((guint) _tmp1_)) {
		gchar* key = NULL;
		gchar* _tmp2_;
		GSettings* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = g_strdup_printf ("key%02u", index);
		key = _tmp2_;
		_tmp3_ = self->priv->settings;
		_tmp4_ = key;
		g_settings_reset (_tmp3_, _tmp4_);
		_g_free0 (key);
	}
}

void
properties_keys_reset_all (PropertiesKeys* self)
{
	g_return_if_fail (self != NULL);
	{
		gint index = 0;
		index = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					index = index + 1;
					_tmp1_ = index;
				}
				_tmp0_ = FALSE;
				_tmp2_ = properties_keys_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(index < _tmp3_)) {
					break;
				}
				properties_keys_reset (self, (guint) index);
			}
		}
	}
}

gint
properties_keys_get_size (PropertiesKeys* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = 9;
	return result;
}

static void
properties_value_keys_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
properties_value_keys_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		properties_keys_unref (value->data[0].v_pointer);
	}
}

static void
properties_value_keys_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = properties_keys_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
properties_value_keys_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
properties_value_keys_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PropertiesKeys * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = properties_keys_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
properties_value_keys_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	PropertiesKeys ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = properties_keys_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
properties_param_spec_keys (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	PropertiesParamSpecKeys* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PROPERTIES_TYPE_KEYS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
properties_value_get_keys (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PROPERTIES_TYPE_KEYS), NULL);
	return value->data[0].v_pointer;
}

void
properties_value_set_keys (GValue* value,
                           gpointer v_object)
{
	PropertiesKeys * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PROPERTIES_TYPE_KEYS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PROPERTIES_TYPE_KEYS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		properties_keys_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		properties_keys_unref (old);
	}
}

void
properties_value_take_keys (GValue* value,
                            gpointer v_object)
{
	PropertiesKeys * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PROPERTIES_TYPE_KEYS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PROPERTIES_TYPE_KEYS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		properties_keys_unref (old);
	}
}

static void
properties_keys_class_init (PropertiesKeysClass * klass,
                            gpointer klass_data)
{
	properties_keys_parent_class = g_type_class_peek_parent (klass);
	((PropertiesKeysClass *) klass)->finalize = properties_keys_finalize;
	g_type_class_adjust_private_offset (klass, &PropertiesKeys_private_offset);
}

static void
properties_keys_instance_init (PropertiesKeys * self,
                               gpointer klass)
{
	self->priv = properties_keys_get_instance_private (self);
	self->ref_count = 1;
}

static void
properties_keys_finalize (PropertiesKeys * obj)
{
	PropertiesKeys * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PROPERTIES_TYPE_KEYS, PropertiesKeys);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->settings);
}

static GType
properties_keys_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { properties_value_keys_init, properties_value_keys_free_value, properties_value_keys_copy_value, properties_value_keys_peek_pointer, "p", properties_value_keys_collect_value, "p", properties_value_keys_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesKeysClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_keys_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PropertiesKeys), 0, (GInstanceInitFunc) properties_keys_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType properties_keys_type_id;
	properties_keys_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PropertiesKeys", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PropertiesKeys_private_offset = g_type_add_instance_private (properties_keys_type_id, sizeof (PropertiesKeysPrivate));
	return properties_keys_type_id;
}

GType
properties_keys_get_type (void)
{
	static volatile gsize properties_keys_type_id__volatile = 0;
	if (g_once_init_enter (&properties_keys_type_id__volatile)) {
		GType properties_keys_type_id;
		properties_keys_type_id = properties_keys_get_type_once ();
		g_once_init_leave (&properties_keys_type_id__volatile, properties_keys_type_id);
	}
	return properties_keys_type_id__volatile;
}

gpointer
properties_keys_ref (gpointer instance)
{
	PropertiesKeys * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
properties_keys_unref (gpointer instance)
{
	PropertiesKeys * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PROPERTIES_KEYS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
value_properties_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_properties_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		properties_unref (value->data[0].v_pointer);
	}
}

static void
value_properties_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = properties_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_properties_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_properties_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Properties * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = properties_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_properties_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	Properties ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = properties_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_properties (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecProperties* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PROPERTIES), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_properties (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROPERTIES), NULL);
	return value->data[0].v_pointer;
}

void
value_set_properties (GValue* value,
                      gpointer v_object)
{
	Properties * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROPERTIES));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROPERTIES));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		properties_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		properties_unref (old);
	}
}

void
value_take_properties (GValue* value,
                       gpointer v_object)
{
	Properties * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROPERTIES));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROPERTIES));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		properties_unref (old);
	}
}

static void
properties_class_init (PropertiesClass * klass,
                       gpointer klass_data)
{
	properties_parent_class = g_type_class_peek_parent (klass);
	((PropertiesClass *) klass)->finalize = properties_finalize;
	g_type_class_adjust_private_offset (klass, &Properties_private_offset);
	properties_signals[PROPERTIES_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PROPERTIES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
properties_instance_init (Properties * self,
                          gpointer klass)
{
	self->priv = properties_get_instance_private (self);
	self->ref_count = 1;
}

static void
properties_finalize (Properties * obj)
{
	Properties * self;
	GSettings* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROPERTIES, Properties);
	g_signal_handlers_destroy (self);
	_tmp0_ = self->priv->settings;
	g_signal_handler_disconnect ((GObject*) _tmp0_, self->priv->notify_handler_id);
	_g_object_unref0 (self->priv->settings);
	_properties_keys_unref0 (self->priv->_keys);
}

static GType
properties_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_properties_init, value_properties_free_value, value_properties_copy_value, value_properties_peek_pointer, "p", value_properties_collect_value, "p", value_properties_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Properties), 0, (GInstanceInitFunc) properties_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType properties_type_id;
	properties_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Properties", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Properties_private_offset = g_type_add_instance_private (properties_type_id, sizeof (PropertiesPrivate));
	return properties_type_id;
}

GType
properties_get_type (void)
{
	static volatile gsize properties_type_id__volatile = 0;
	if (g_once_init_enter (&properties_type_id__volatile)) {
		GType properties_type_id;
		properties_type_id = properties_get_type_once ();
		g_once_init_leave (&properties_type_id__volatile, properties_type_id);
	}
	return properties_type_id__volatile;
}

gpointer
properties_ref (gpointer instance)
{
	Properties * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
properties_unref (gpointer instance)
{
	Properties * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PROPERTIES_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

