/* theme.c generated by valac 0.48.15, the Vala compiler
 * generated from theme.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;

#define TYPE_GAMES_PREIMAGE (games_preimage_get_type ())
#define GAMES_PREIMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAMES_PREIMAGE, GamesPreimage))
#define GAMES_PREIMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAMES_PREIMAGE, GamesPreimageClass))
#define IS_GAMES_PREIMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAMES_PREIMAGE))
#define IS_GAMES_PREIMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAMES_PREIMAGE))
#define GAMES_PREIMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAMES_PREIMAGE, GamesPreimageClass))

typedef struct _GamesPreimage GamesPreimage;
typedef struct _GamesPreimageClass GamesPreimageClass;
typedef enum  {
	THEME_FRAMES_PLAYER_START = 0,
	THEME_FRAMES_PLAYER_DEAD = 4,
	THEME_FRAMES_ROBOT1_START = 5,
	THEME_FRAMES_ROBOT2_START = 9,
	THEME_FRAMES_HEAP_START = 13,
	THEME_FRAMES_COUNT = 14,
	THEME_FRAMES_NUM_PLAYER_ANIMATIONS = THEME_FRAMES_PLAYER_DEAD - THEME_FRAMES_PLAYER_START,
	THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS = THEME_FRAMES_ROBOT1_START - THEME_FRAMES_PLAYER_DEAD,
	THEME_FRAMES_NUM_PLAYER_TILES = THEME_FRAMES_ROBOT1_START - THEME_FRAMES_PLAYER_START,
	THEME_FRAMES_NUM_ROBOT1_ANIMATIONS = THEME_FRAMES_ROBOT2_START - THEME_FRAMES_ROBOT1_START,
	THEME_FRAMES_NUM_ROBOT2_ANIMATIONS = THEME_FRAMES_HEAP_START - THEME_FRAMES_ROBOT2_START,
	THEME_FRAMES_NUM_HEAP_ANIMATIONS = THEME_FRAMES_COUNT - THEME_FRAMES_HEAP_START
} ThemeFrames;

#define THEME_TYPE_FRAMES (theme_frames_get_type ())
#define _games_preimage_unref0(var) ((var == NULL) ? NULL : (var = (games_preimage_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _theme_unref0(var) ((var == NULL) ? NULL : (var = (theme_unref (var), NULL)))
typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())
typedef struct _ParamSpecTheme ParamSpecTheme;

struct _Theme {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GTypeClass parent_class;
	void (*finalize) (Theme *self);
};

struct _ThemePrivate {
	GamesPreimage* preimage;
	GdkPixbuf* pixbuf;
	gint tile_width;
	gint tile_height;
	gchar* _path;
	gchar* _name;
};

struct _ParamSpecTheme {
	GParamSpec parent_instance;
};

static gint Theme_private_offset;
static gpointer theme_parent_class = NULL;

gpointer theme_ref (gpointer instance);
void theme_unref (gpointer instance);
GParamSpec* param_spec_theme (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_theme (GValue* value,
                      gpointer v_object);
void value_take_theme (GValue* value,
                       gpointer v_object);
gpointer value_get_theme (const GValue* value);
GType theme_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, theme_unref)
gpointer games_preimage_ref (gpointer instance);
void games_preimage_unref (gpointer instance);
GParamSpec* param_spec_games_preimage (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_games_preimage (GValue* value,
                               gpointer v_object);
void value_take_games_preimage (GValue* value,
                                gpointer v_object);
gpointer value_get_games_preimage (const GValue* value);
GType games_preimage_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesPreimage, games_preimage_unref)
GType theme_frames_get_type (void) G_GNUC_CONST;
Theme* theme_new_from_file (const gchar* path,
                            const gchar* name,
                            GError** error);
Theme* theme_construct_from_file (GType object_type,
                                  const gchar* path,
                                  const gchar* name,
                                  GError** error);
GamesPreimage* games_preimage_new_from_file (const gchar* filename,
                                             GError** error);
GamesPreimage* games_preimage_construct_from_file (GType object_type,
                                                   const gchar* filename,
                                                   GError** error);
static void theme_set_path (Theme* self,
                     const gchar* value);
static void theme_set_name (Theme* self,
                     const gchar* value);
GType object_type_get_type (void) G_GNUC_CONST;
void theme_draw_object (Theme* self,
                        ObjectType type,
                        gint frame_no,
                        cairo_t* cr,
                        gint width,
                        gint height);
GdkPixbuf* games_preimage_render (GamesPreimage* self,
                                  gint width,
                                  gint height);
Theme* theme_new (void);
Theme* theme_construct (GType object_type);
const gchar* theme_get_path (Theme* self);
const gchar* theme_get_name (Theme* self);
static void theme_finalize (Theme * obj);
static GType theme_get_type_once (void);

static inline gpointer
theme_get_instance_private (Theme* self)
{
	return G_STRUCT_MEMBER_P (self, Theme_private_offset);
}

static GType
theme_frames_get_type_once (void)
{
	static const GEnumValue values[] = {{THEME_FRAMES_PLAYER_START, "THEME_FRAMES_PLAYER_START", "player-start"}, {THEME_FRAMES_PLAYER_DEAD, "THEME_FRAMES_PLAYER_DEAD", "player-dead"}, {THEME_FRAMES_ROBOT1_START, "THEME_FRAMES_ROBOT1_START", "robot1-start"}, {THEME_FRAMES_ROBOT2_START, "THEME_FRAMES_ROBOT2_START", "robot2-start"}, {THEME_FRAMES_HEAP_START, "THEME_FRAMES_HEAP_START", "heap-start"}, {THEME_FRAMES_COUNT, "THEME_FRAMES_COUNT", "count"}, {THEME_FRAMES_NUM_PLAYER_ANIMATIONS, "THEME_FRAMES_NUM_PLAYER_ANIMATIONS", "num-player-animations"}, {THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS, "THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS", "num-player-dead-animations"}, {THEME_FRAMES_NUM_PLAYER_TILES, "THEME_FRAMES_NUM_PLAYER_TILES", "num-player-tiles"}, {THEME_FRAMES_NUM_ROBOT1_ANIMATIONS, "THEME_FRAMES_NUM_ROBOT1_ANIMATIONS", "num-robot1-animations"}, {THEME_FRAMES_NUM_ROBOT2_ANIMATIONS, "THEME_FRAMES_NUM_ROBOT2_ANIMATIONS", "num-robot2-animations"}, {THEME_FRAMES_NUM_HEAP_ANIMATIONS, "THEME_FRAMES_NUM_HEAP_ANIMATIONS", "num-heap-animations"}, {0, NULL, NULL}};
	GType theme_frames_type_id;
	theme_frames_type_id = g_enum_register_static ("ThemeFrames", values);
	return theme_frames_type_id;
}

GType
theme_frames_get_type (void)
{
	static volatile gsize theme_frames_type_id__volatile = 0;
	if (g_once_init_enter (&theme_frames_type_id__volatile)) {
		GType theme_frames_type_id;
		theme_frames_type_id = theme_frames_get_type_once ();
		g_once_init_leave (&theme_frames_type_id__volatile, theme_frames_type_id);
	}
	return theme_frames_type_id__volatile;
}

Theme*
theme_construct_from_file (GType object_type,
                           const gchar* path,
                           const gchar* name,
                           GError** error)
{
	Theme* self = NULL;
	GamesPreimage* _tmp0_ = NULL;
	GamesPreimage* _tmp1_;
	GamesPreimage* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (Theme*) g_type_create_instance (object_type);
	_tmp1_ = games_preimage_new_from_file (path, &_inner_error0_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_theme_unref0 (self);
		return NULL;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	_games_preimage_unref0 (self->priv->preimage);
	self->priv->preimage = _tmp2_;
	_g_object_unref0 (self->priv->pixbuf);
	self->priv->pixbuf = NULL;
	theme_set_path (self, path);
	theme_set_name (self, name);
	_games_preimage_unref0 (_tmp0_);
	return self;
}

Theme*
theme_new_from_file (const gchar* path,
                     const gchar* name,
                     GError** error)
{
	return theme_construct_from_file (TYPE_THEME, path, name, error);
}

void
theme_draw_object (Theme* self,
                   ObjectType type,
                   gint frame_no,
                   cairo_t* cr,
                   gint width,
                   gint height)
{
	gint tile_no = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	tile_no = -1;
	switch (type) {
		case OBJECT_TYPE_PLAYER:
		{
			tile_no = (gint) (THEME_FRAMES_PLAYER_START + (frame_no % THEME_FRAMES_NUM_PLAYER_TILES));
			break;
		}
		case OBJECT_TYPE_ROBOT1:
		{
			tile_no = (gint) (THEME_FRAMES_ROBOT1_START + (frame_no % THEME_FRAMES_NUM_ROBOT1_ANIMATIONS));
			break;
		}
		case OBJECT_TYPE_ROBOT2:
		{
			tile_no = (gint) (THEME_FRAMES_ROBOT2_START + (frame_no % THEME_FRAMES_NUM_ROBOT2_ANIMATIONS));
			break;
		}
		case OBJECT_TYPE_HEAP:
		{
			tile_no = (gint) (THEME_FRAMES_HEAP_START + (frame_no % THEME_FRAMES_NUM_HEAP_ANIMATIONS));
			break;
		}
		case OBJECT_TYPE_NONE:
		{
			return;
		}
		default:
		break;
	}
	_tmp2_ = self->priv->pixbuf;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = self->priv->tile_width != width;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->tile_height != height;
	}
	if (_tmp0_) {
		GamesPreimage* _tmp3_;
		GdkPixbuf* _tmp4_;
		self->priv->tile_width = width;
		self->priv->tile_height = height;
		_tmp3_ = self->priv->preimage;
		_tmp4_ = games_preimage_render (_tmp3_, (gint) (THEME_FRAMES_COUNT * self->priv->tile_width), self->priv->tile_height);
		_g_object_unref0 (self->priv->pixbuf);
		self->priv->pixbuf = _tmp4_;
	}
	_tmp5_ = self->priv->pixbuf;
	gdk_cairo_set_source_pixbuf (cr, _tmp5_, (gdouble) ((-tile_no) * self->priv->tile_width), (gdouble) 0);
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) self->priv->tile_width, (gdouble) self->priv->tile_height);
	cairo_fill (cr);
}

Theme*
theme_construct (GType object_type)
{
	Theme* self = NULL;
	self = (Theme*) g_type_create_instance (object_type);
	return self;
}

Theme*
theme_new (void)
{
	return theme_construct (TYPE_THEME);
}

const gchar*
theme_get_path (Theme* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_path;
	result = _tmp0_;
	return result;
}

static void
theme_set_path (Theme* self,
                const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_path);
	self->priv->_path = _tmp0_;
}

const gchar*
theme_get_name (Theme* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
theme_set_name (Theme* self,
                const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
}

static void
value_theme_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_theme_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		theme_unref (value->data[0].v_pointer);
	}
}

static void
value_theme_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = theme_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_theme_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_theme_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Theme * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = theme_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_theme_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Theme ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = theme_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_theme (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecTheme* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_THEME), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_theme (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_THEME), NULL);
	return value->data[0].v_pointer;
}

void
value_set_theme (GValue* value,
                 gpointer v_object)
{
	Theme * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_THEME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_THEME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		theme_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		theme_unref (old);
	}
}

void
value_take_theme (GValue* value,
                  gpointer v_object)
{
	Theme * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_THEME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_THEME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		theme_unref (old);
	}
}

static void
theme_class_init (ThemeClass * klass,
                  gpointer klass_data)
{
	theme_parent_class = g_type_class_peek_parent (klass);
	((ThemeClass *) klass)->finalize = theme_finalize;
	g_type_class_adjust_private_offset (klass, &Theme_private_offset);
}

static void
theme_instance_init (Theme * self,
                     gpointer klass)
{
	self->priv = theme_get_instance_private (self);
	self->ref_count = 1;
}

static void
theme_finalize (Theme * obj)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
	g_signal_handlers_destroy (self);
	_games_preimage_unref0 (self->priv->preimage);
	_g_object_unref0 (self->priv->pixbuf);
	_g_free0 (self->priv->_path);
	_g_free0 (self->priv->_name);
}

static GType
theme_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_theme_init, value_theme_free_value, value_theme_copy_value, value_theme_peek_pointer, "p", value_theme_collect_value, "p", value_theme_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType theme_type_id;
	theme_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Theme", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Theme_private_offset = g_type_add_instance_private (theme_type_id, sizeof (ThemePrivate));
	return theme_type_id;
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		GType theme_type_id;
		theme_type_id = theme_get_type_once ();
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}

gpointer
theme_ref (gpointer instance)
{
	Theme * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
theme_unref (gpointer instance)
{
	Theme * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		THEME_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

